Package tigase.xmpp.impl

# Class LastActivityMarker

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
tigase.xmpp.impl.LastActivityAbstract
tigase.xmpp.impl.LastActivityMarker

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `RegistrarBean`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`, `XMPPStopListenerIfc`

@Bean(name="jabber:iq:last-marker", parent=SessionManager.class, active=false) public class LastActivityMarker extends LastActivityAbstract implements XMPPStopListenerIfc, RegistrarBean
Implementation of XEP-0012: Last Activity.

Author:
  bmalkow

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `ID`

  ### Fields inherited from class tigase.xmpp.impl.LastActivityAbstract

  `LAST_ACTIVITY_KEY, LAST_PRESENCE_KEY, LAST_SHOW_KEY, LAST_STATUS_KEY, SHOW_PATH, STATUS_PATH, XMLNS`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LastActivityMarker()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  `void`
  `register(Kernel kernel)`
  Method called when bean is being registered allowing developer to programatically register other beans.
  `void`
  `setRetrievers(LastActivityRetriever[] retrievers)`
  `void`
  `stopped(XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)`
  Performs additional processing upon closing user session (user either disconnects or logs-out).
  `void`
  `unregister(Kernel kernel)`
  Method called while bean is being unregistered.

  ### Methods inherited from class tigase.xmpp.impl.LastActivityAbstract

  `getLastActivity, getLastActivity, getLastActivity, getPresence, getShow, getShow, getStatus, getStatus, getType, getType, persistLastActivity`

  ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

  `id, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, id, init, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

- ## Field Details

  - ### ID

    protected static final String ID
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### LastActivityMarker

    public LastActivityMarker()

- ## Method Details

  - ### setRetrievers

    public void setRetrievers(LastActivityRetriever[] retrievers)

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### stopped

    public void stopped(XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)
    Description copied from interface: `XMPPStopListenerIfc`
    Performs additional processing upon closing user session (user either disconnects or logs-out).
    Specified by:
      `stopped` in interface `XMPPStopListenerIfc`
    Parameters:
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.

  - ### register

    public void register(Kernel kernel)
    Description copied from interface: `RegistrarBean`
    Method called when bean is being registered allowing developer to programatically register other beans.
    Specified by:
      `register` in interface `RegistrarBean`
    Parameters:
      `kernel` - - instance from local scope

  - ### unregister

    public void unregister(Kernel kernel)
    Description copied from interface: `RegistrarBean`
    Method called while bean is being unregistered.
    Specified by:
      `unregister` in interface `RegistrarBean`
    Parameters:
      `kernel` - - instance from local scope